<script setup>
</script>

<script>
import jQuery from "jquery";
import Jszip from 'jszip';
import DataTable from 'datatables.net-vue3';
import DataTableLib from 'datatables.net-bs5';
import 'datatables.net-buttons-bs5';
import 'datatables.net-buttons/js/buttons.html5.mjs';
import DataTableResponsive from "datatables.net-bs5";
import axios from 'axios';
import $ from 'jquery';
import swal from 'sweetalert';
import Multiselect from '@vueform/multiselect'
import '@vueform/multiselect/themes/default.css'

// Configurar JSZip
window.JSZip = Jszip;

// Inicializar DataTables con las bibliotecas
DataTable.use(DataTableLib);
DataTable.use(DataTableResponsive);

document.addEventListener("DOMContentLoaded", function () {
  // Obtener la tabla DataTable

  const dataTable = $('#datatable-index').DataTable();
  

  // Agregar un evento de clic a los elementos con la clase "eliminar" dentro de la tabla

  dataTable.on("click", ".sancionar", function (rfc) {
    const rowData = dataTable.row($(this).closest("tr")).data();
    if (rowData) {
      const rfc = rowData.rfc;
      window.location.href = route('sanciones.create.servidores.publicos', {rfc:rfc});
    }
  });


  dataTable.on("click", ".detalles", function (rfc) {
    const rowData = dataTable.row($(this).closest("tr")).data();
    if (rowData) {
      const rfc = rowData.rfc;
      window.location.href = route('servidores.publicos.show',rfc);
    }
  });


});

export default {
  components: { DataTable, Multiselect },
  data() {
    return {
      products: null,
      rfc:'',
      fechaFinal: '',
      rango:'',
      sancionesIds: '',
      InstitucionesIds:'',
      faltaIds:'',
      responsableSancionIds:'',
      admin:this.variables.sancionesAdd,
      TipoFalta: [],
	      Faltas:this.variables && this.variables.tiposFalta
	      ? this.variables.tiposFalta.map(item => item)
	      : [],

        ResponsableSancion: null,
	      Responsables:this.variables && this.variables.responsablesSancion
	      ? this.variables.responsablesSancion.map(item => item)
	      : [],
      


      InstitucionSancionadora: [],
	      OpcionesInstituciones: this.variables && this.variables.institucionesDependencias
	      ? this.variables.institucionesDependencias.map(item => item)
	      : [],

        TiposSancion: [],
	      Sanciones: this.variables && this.variables.tiposSancion
	      ? this.variables.tiposSancion.map(item => item)
	      : [],
        TiposSancionSeleccionados: [],
      loadingData: false,
      columns: [
        { data: null, render: function (data, type, row, meta) { return `${meta.row + 1}` } },
        { data: 'rfc', searchable: true }, // Habilitar búsqueda en esta columna
         { data: 'nombreCompleto', searchable: true },
        { data: 'institucionDependencia.nombre'}, 
           {
  data: null,
  render: (data, type, row) => {
    if (this.admin == true) {
      return '<a title="Detalles" href="#a" v-on:click="detalles(rfc)" class="detalles text-warning"><i class=" mdi mdi-eye font-size-18"></i></a> <a href="#a" v-on:click="sancionar(rfc)" class="sancionar text-info" title="Sancionar"><i class="mdi mdi-clipboard-text font-size-20"></i></a>';
    } else {
      return '<a title="Detalles" href="#a" v-on:click="detalles(rfc)" class="detalles text-warning"><i class=" mdi mdi-eye font-size-18"></i></a>';
    }
  }
}
      ],
    }
  },

  mounted() {
    const dataTable = $('#datatable-index').DataTable();
    this.getProducts();
    this.initDataTable();
    
  },

  watch: {
	 
   InstitucionSancionadora: function(newValue) {
     
     // Obtener los IDs de las opciones seleccionadas
     const selectedIds = newValue.map(option => {
       const selectedOption = this.OpcionesInstituciones.find(institucion => institucion.nombre === option);
       return selectedOption ? selectedOption.id : null;
     });
 
 
     const selectedNombres = newValue.map(option => {
     const selectedOption = this.OpcionesInstituciones.find(institucion => institucion.nombre === option);
     return selectedOption ? selectedOption.nombre : null;
     });
 
   
     this.sancionesNombre = selectedNombres
     this.InstitucionesIds = selectedIds;
 
     console.log(this.sancionesNombre);
     console.log(this.InstitucionesIds);
   
   },

 },

  props: {
	    variables: Object,
	},

  

  methods: {
    getProducts() {
      swal({
    icon: 'info',
    text: 'Cargando registros...',
    buttons: false,
    closeOnClickOutside: false,
    closeOnEsc: false,
  });
      axios.get(route('servidores.publicos.get.all')).then(
        response => {
          console.log(response.data)
          this.products = response.data.data
        }
      )
    },

    filtroBusqueda() {

swal({
icon: 'info',
text: 'Cargando registros...',
buttons: false,
closeOnClickOutside: false,
closeOnEsc: false,
});





const dataTable = $('#datatable-index').DataTable({

dom: 'Bfrtip', // Agrega el contenedor de botones
buttons: [
{
extend: 'excelHtml5', // Extensión para exportar a Excel
title: 'Lista de Servidores Publicos', // Título del archivo Excel
text: '<i class ="mdi mdi-file-excel"></i> Descargar Excel',
className: 'btn btn-success',
exportOptions: {
columns: [1,2, 3,] // Índices de las columnas a exportar (ajusta esto según tus necesidades)
}
},
],
destroy: true,
serverSide: true,
ajax: {
url: route('servidores.publicos.get.all', {rfc:this.rfc,institucionesIds:this.InstitucionesIds}),
type: 'GET',
dataSrc: function (json) {
json.recordsTotal = json.total;
json.recordsFiltered = json.total;
return json.data;

},
data: d => {
d.page = (d.start / d.length) + 1;
},
},
columns: this.columns,

searching: true,




language: {
processing: "Procesando...",
search: "Buscar:",
lengthMenu: "Mostrar _MENU_ registros",
info: "Mostrando desde _START_ al _END_ de _TOTAL_ registros",
infoEmpty: "Mostrando ningún elemento.",
infoFiltered: "(filtrado _MAX_ elementos total)",
infoPostFix: "",
loadingRecords: "Cargando registros...",
zeroRecords: "No se encontraron registros",
emptyTable: "No hay datos disponibles en la tabla",
paginate: {
first: "Primero",
previous: "Anterior",
next: "Siguiente",
last: "Último"
},
aria: {
sortAscending: ": activar para ordenar la columna ascendente",
sortDescending: ": activar para ordenar la columna descendente"
}
},

});
this.bindTableEvents(dataTable);

},

bindTableEvents(dataTable) {
  dataTable.on("click", ".sancionar", function (rfc) {
    const rowData = dataTable.row($(this).closest("tr")).data();
    if (rowData) {
      const rfc = rowData.rfc;
      window.location.href = route('sanciones.create.servidores.publicos', {rfc:rfc});
    }
  });


  dataTable.on("click", ".detalles", function (rfc) {
    const rowData = dataTable.row($(this).closest("tr")).data();
    if (rowData) {
      const rfc = rowData.rfc;
      window.location.href = route('servidores.publicos.show',rfc);
    }
  });
},



    initDataTable() {
    const dataTable = $('#datatable-index').DataTable({

      dom: 'Bfrtip', // Agrega el contenedor de botones
    buttons: [
      {
        extend: 'excelHtml5', // Extensión para exportar a Excel
        title: 'Lista de Servidores Publicos', // Título del archivo Excel
        text: '<i class ="mdi mdi-file-excel"></i> Descargar Excel',
        className: 'btn btn-success',
        exportOptions: {
        columns: [1,2, 3,] // Índices de las columnas a exportar (ajusta esto según tus necesidades)
    }
      },
    ],
      destroy: true,
      serverSide: true,
      ajax: {
        url: route('servidores.publicos.get.all'),
        type: 'GET',
        dataSrc: function (json) {
            json.recordsTotal = json.total;
            json.recordsFiltered = json.total;
            return json.data;
        },
        data: d => {
          d.page = (d.start / d.length) + 1;
        },
      },
      columns: this.columns,

      searching: true,

      
      

      language: {
          processing: "Procesando...",
          search: "Buscar:",
          lengthMenu: "Mostrar _MENU_ registros",
          info: "Mostrando desde _START_ al _END_ de _TOTAL_ registros",
          infoEmpty: "Mostrando ningún elemento.",
          infoFiltered: "(filtrado _MAX_ elementos total)",
          infoPostFix: "",
          loadingRecords: "Cargando registros...",
          zeroRecords: "No se encontraron registros",
          emptyTable: "No hay datos disponibles en la tabla",
          paginate: {
            first: "Primero",
            previous: "Anterior",
            next: "Siguiente",
            last: "Último"
          },
          aria: {
            sortAscending: ": activar para ordenar la columna ascendente",
            sortDescending: ": activar para ordenar la columna descendente"
          }
        },
        info: "Mostrando desde _START_ al _END_ de _TOTAL_ entradas",
      
    });
    
    dataTable.on('page.dt', () => {
      swal({
        icon: 'info',
        text: 'Cargando registros...',
        buttons: false,
        closeOnClickOutside: false,
        closeOnEsc: false,
      });
    });

    

    // Añadir un event listener para el evento 'draw'.
    dataTable.on('draw.dt', () => {
      setTimeout(() => {
    swal.close();
  }, 8000);
    });
  },

    create: function (event) {
      window.location.href = '/sanciones/create/servidores-publicos';

    }
  }
}
</script>

<template>

        <div class="row">
          <div class="col-lg-12">
            <div class="card">
              <div class="modal fade bs-example-modal-xl" style="margin-left: 100px;" tabindex="-1" role="dialog" aria-labelledby="myExtraLargeModalLabel" aria-hidden="true">
                <div class="modal-dialog modal-xl">
                  <div class="modal-content">
                                      <div class="modal-header">
                                          <h5 class="modal-title">Filtros de busqueda</h5>
                                      </div>
                                      <div class="modal-body">
                                        <div class="row">
                                            <div class="col-md-20">
                                              <div class="mb-3">
                                                <label for="validationCustom03" class="form-label">RFC</label>
                                                <div class="input-group">
                                                  <input name="" type="text" class="form-control" id="validationCustom03" placeholder="RFC" v-model="rfc"/>
                                                  </div> 
                                                </div>
                                            </div>
                                          
                                          <div class="col-md-20">
                                            <div class="mb-3">
                                              <label for="validationCustom14" class="form-label">Instituciones dependencia</label>
                                              <Multiselect
                                                v-model="InstitucionSancionadora"
                                                mode="tags"
                                                :close-on-select="false"
                                                :searchable="true"
                                                placeholder="Seleccione una opción"
                                                :options="OpcionesInstituciones.map(option => option.nombre)"
                                                class="tipoSancion"
                                                :max="3"
                                              />  
                                               <input type="text" hidden name="tiposSancion" v-model="InstitucionesIds">                                                                               
                                            
                                            </div>
                                          </div>

                                          
                                        </div>

                                        <div class="d-grid gap-2 d-md-flex justify-content-md-end">
                                          <button class="btn btn-danger" data-bs-dismiss="modal" aria-label="Close" type="button">Cancelar</button>
                                          <button class="btn btn-primary" data-bs-dismiss="modal" aria-label="Close" @click="filtroBusqueda"  type="submit">Buscar</button>
                                        </div>

                                       

                                      </div>
                                  </div>
                              </div>
                          </div>
              <div class="card-body">
                <div class="dropdown float-end">
                  <button type="button" id="" data-bs-toggle="modal" data-bs-target=".bs-example-modal-xl" class="btn btn-primary waves-effect">
                    <i class="mdi mdi-filter font-size-16 align-middle me-2"></i> Filtros de busqueda
                  </button>
                </div>

                <h4 class="card-title mb-4">Lista de servidores publicos</h4>
                <div class="table-responsive">
                  <DataTable :data="products" :columns="columns" id="datatable-index" class=" table-condensed table table-bordered dt-responsive  nowrap w-100"
                    :options="{responsive:true,autoWidth:false, dom:'Bfrtip',language:{
                      search: 'Buscar', zeroRecords:'No hay registros para mostrar',
                      info:'Mostrando del _START_ a _END_ de _TOTAL_ registros',
                      infoFiltered: '(Filtrados de _MAX_ registros.)',
                      paginate:{first: 'Primero',previous:'Anterior',next:'Siguiente', last:'Último'}
                    },}">
                    <thead class="table-light">
                      <tr>
                        <th style="width: 1%">
                        </th>
                        <th class="align-middle text-center" style="width: 10%;">RFC</th>
                        <th class="align-middle text-center" style="width: 30%;">Nombre</th>
                        <th class="align-middle text-center" style="width: 45%;">Institución</th>
                        <th class="align-middle text-center" style="width: 10%;">Acciones</th>
                      </tr>
                    </thead>
                    <tbody style="text-align: center; font-size: 15px;"></tbody>
                  </DataTable>
                </div>
              </div>
            </div>
          </div>
        </div>
    <footer class="footer"></footer>

</template>

<style>
.dataTables_wrapper .dataTables_filter {
  margin-right: 10px;
}

.dt-buttons btn-group {
  background-color: red;
}

.dataTables_length {
  display: none;
}

#datatable-index{
  margin-top: 10px;
}



@media (min-width: 768px) {
  #TablaPrincipal_wrapper {}
}
</style>